// StatStdLib.cs
// dull@ss-harvester.com
//=========================

if($PlayStats == "" || $PlayStats != false) $PlayStats = true;
if($VehStats != true || $VehStats == "") $VehStats = false;

function player::onAdd(%this)
{
%player.name = getName(%player);

   player::onAddLog(%this);
	
	if($server::TeamPlay == true)
	{
      say(%this,0, *IDMULT_TDM_WELCOME);	      
   }
	else
	{
      say(%this,0, *IDMULT_DM_WELCOME);
   }
}   


function vehShuffle(%player, %vehName)
{
if(%player.vehs == "")
 {
 %player.vehs = 1;
 %player.veh[1] = %vehName;
 return;
 }
%a = "none";
for(%i=1;%i<=%player.vehs;%i++)
 {
 if(%vehName == %player.veh[%i])
  { %a = %i; }
 }
if(%a == "none")
 {
 %player.vehs++;
 %player.veh[%player.vehs] = %vehName;
 %player.vehNum = %player.vehs;
 %player.killsIn[%vehName] = 0;
 %player.deathsIn[%vehName] = 0;
 %player.killsVs[%vehName] = 0;
 %player.deathsVs[%vehName] = 0;
 }
else
 {
 %player.vehNum = %a;
 }
}
 

function vehicle::onAdd(%this)
{
%player = playerManager::vehicleIdToPlayerNum(%this);
%player.name = getName(%player);
%veh = getVehicleName(%this);
if(%veh != %player.veh)
 {
 %player.veh = %veh;
 vehShuffle(%player, %veh);
 }

   if($server::TeamPlay != true)
   {
   	// see if it is a player
      %player = playerManager::vehicleIdToPlayerNum(%this);
      if(%player == 0)  // that's the server
         return;
         
      // so it's a player
      
      // shouldn't have to do this, but oh well
      setTeam(%this, *IDSTR_TEAM_RED);
   }
}



function vehicle::onDestroyed(%destroyed, %destroyer)
{
 // left over from DMstdLib.cs
   // left over from missionStdLib.cs
   vehicle::onDestroyedLog(%destroyed, %destroyer);
   
   // this is weird but %destroyer isn't necessarily a vehicle
   %message = getFancyDeathMessage(getHUDName(%destroyed), getHUDName(%destroyer));
   if(%message != "")
   {
      say( 0, 0, %message);
   }
   
   // enforce the rules
   if($server::TeamPlay == true)
   {
      if(
         (getTeam(%destroyed) == getTeam(%destroyer)) &&
         (%destroyed != %destroyer)
      )
      {
         antiTeamKill(%destroyer);
      }
   }   

%killer = playerManager::vehicleIdToPlayerNum(%destroyer);
%killed = playerManager::vehicleIdToPlayerNum(%destroyed);
%erName = getName(%killer);
%edName = getName(%killed);

if(%killer == %killed)
 {
 if(%player.suicides == "") %player.suicides = 0;
 %player.suicides++;
 %player.DeathsIn[%player.veh]++;
 return;
 }

opponentShuffle(%killer, %killed);
opponentShuffle(%killed, %killer);

if(%killer.killsVs[%edName] == "") %killer.killsVs[%edName] = 0;
if(%killed.deathsVs[%erName] == "") %killed.deathsVs[%erName] = 0;
%killer.killsVs[%edName]++;
%killed.deathsVs[%erName]++;

%killer.killsIn[%killer.veh]++;
%killed.deathsIn[%killed.veh]++;

if(%killer.killsVsVeh[%killed.veh] == "") vehShuffle(%killer, %killed.veh);
if(%killed.deathsVsVeh[%killer.veh] == "") vehShuffle(%killed, %killer.veh);
%killer.killsVsVeh[%killed.veh]++;
%killed.deathsVsVeh[%killer.veh]++;
}


function opponentShuffle(%player, %opp)
{
%opp = getName(%opp);
if(%player.opps == "")
 {
 %player.opps = 1;
 %player.opp[1] = %opp;
 return;
 }
%a = "none";
for(%i=1;%i<=%player.opps;%i++)
 {
 if(%opp == %player.opp[%i])
  { %a = %i; }
 }
if(%a == "none")
 {
 %player.opps++;
 %player.opp[%player.opps] = %opp;
 }
}


function onMissionEnd()
{
displayStats();
clearVariables();
}

function displayStats()
{
%c = playerManager::getPlayerCount();
for(%i=0;%i<%c;%i++)
 {
 %player = playerManager::getPlayerNum(%i);
 if($PlayStats == true)
  {
  say(%player, 0, "<F5>Player Stats");
  for(%j=1;%j<=%player.opps;%j++)
   {
   if(%player.killsVs[%player.opp[%j]] == "") %player.killsVs[%player.opp[%j]] = 0;
   if(%player.deathsVs[%player.opp[%j]] == "") %player.deathsVs[%player.opp[%j]] = 0;
   say(%player, 0, "<F4>"@%player.opp[%j]@":   <F0>"@%player.killsVs[%player.opp[%j]]@" kills. "@%player.deathsVs[%player.opp[%j]]@" deaths.");
   }
  if(%player.suicides == "") %player.suicides = 0;
  say(%player, 0, "<F4>Suicides: <F0>"@%player.suicides);
  }
 if($VehStats == true)
  {
  say(%player, 0, "<F5>Vehicle Stats");
  for(%j=1;%j<=%player.vehs;%j++)
   {
   if(%player.killsIn[%player.veh[%j]] == "") %player.killsIn[%player.veh[%j]] = 0;
   if(%player.killsVsVeh[%player.veh[%j]] == "") %player.killsVsVeh[%player.veh[%j]] = 0;
   if(%player.deathsIn[%player.veh[%j]] == "") %player.deathsIn[%player.veh[%j]] = 0;
   if(%player.deathsVsVeh[%player.veh[%j]] == "") %player.deathsVsVeh[%player.veh[%j]] = 0;
 
   say(%player, 0, "<F4>"@%player.veh[%j]@": "@
 "<F0> "@%player.killsVsVeh[%player.veh[%j]]@" kills against." @
 "<F0> "@%player.deathsVsVeh[%player.veh[%j]]@" deaths against.");
 say(%player, 0, "<F0> "@%player.killsIn[%player.veh[%j]]@" kills while used." @
 "<F0> "@%player.deathsIn[%player.veh[%j]]@" deaths while used."); 
  
   }
  }
 }
}

function clearVariables()
{
%c = playerManager::getPlayerCount();
for(%i=0;%i<%c;%i++)
 {
 %player = playerManager::getPlayerNum(%i);

 for(%j=1;%j<=%player.opps;%j++)
  {
  %player.killsVs[%player.opp[%j]] = "";
  %player.deathsVs[%player.opp[%j]] = "";
  %player.opp[%j] = "";
  }
 %player.opps = "";
 for(%j=1;%j<=%player.vehs;%j++)
  {
  %player.killsIn[%player.veh[%j]] = "";
  %player.killsVsVeh[%player.veh[%j]] = "";
  %player.deathsIn[%player.veh[%j]] = "";
  %player.deathsVsVeh[%player.veh[%j]] = "";
  %player.veh[%j] = "";
  }
 %player.vehs = "";
 %player.veh = "";
 %player.suicides = "";
 }
}

function vehicle::onScan(%scanned, %scanner)
{
%player = playerManager::vehicleIdToPlayerNum(%scanner);
%played = playerManager::vehicleIdToPlayerNum(%scanned);

if(!%played) return;

if(%player.killsVs[%played] == "") %player.killsVs[%played] = 0;
if(%player.deathsVs[%played] == "") %player.deathsVs[%played] = 0;
say(%player, 0, "<F0>Stats vs "@getName(%played)@"<F4>: "@%player.killsVs[%played]@" kills, "@%player.deathsVs[%played]@" deaths.");

if(%player.killsIn[%player.veh] == "") %player.killsIn[%player.veh] = 0;
if(%player.DeathsIn[%player.veh] == "") %player.DeathsVsVeh[%played.veh] = 0;
say(%player, 0, "<F4>You have made kills "@%player.killsIn[%player.veh]@" in "@%player.veh@"s and died "@%player.DeathsVsVeh[%played.veh]@" times against "@%played.veh@"s.");
}



// Presented by:  +-------------------------+
//                | FLYING DUCK PRODUCTIONS |
//                |       <^>(o o)<^>       |
//                |           \_/           |
//                +-------------------------+
// END